#pragma once

#include "matrix_new.h"
#include "graph.h"

#include <vector>
#include <limits>
#include <set> //хранит уникальные элементы в отсортированном порядке

using node_name_t = unsigned int;
using weight_t = double;
using matrix_t = linalg::Matrix<weight_t>;

template<typename T>
using graph_t = graph::Graph<node_name_t, T, weight_t>;
using components_t = std::set<std::set<node_name_t>>;
using route_t = std::vector<node_name_t>;

const double INF = std::numeric_limits<double>::infinity();
const double EPS = std::numeric_limits<double>::epsilon();


