

#pragma once

#include "laba3.h"
#include <unordered_map>
#include <iostream>
#include <sstream>
#include <algorithm>
#include <deque>
#include <stdexcept>

node_name_t convert (const char* str) {
    using namespace std::string_literals;
    node_name_t value = 0;
    std::istringstream sout(str);
    if (!(sout >> value).eof())
        throw std::runtime_error("Invalid argument parametr: "s + str); //если после чтения не был достигнут конец файла, то генерируется и выбрасывается исключение с сообщением об ошибке
    return value;
}

std::tuple<const char*, node_name_t, node_name_t> parse_args(int arg_count, char* arg_vars[]) {
    using namespace std::string_literals;
    if (arg_count != 7)
        throw std::runtime_error("Invalid number of arguments!");

    std::unordered_map<std::string, const char*> args = {
            {"--file", nullptr},
            {"--from", nullptr},
            {"--to", nullptr}
    };
    for (char** t = arg_vars + 1; t < arg_vars + arg_count; t += 2) {
        auto it = args.find(*t);
        if (it == args.end())
            throw std::runtime_error("Invalid argument: "s + *t);
        auto& [key, value] = *it;
        if (value != nullptr)
            throw std::runtime_error("Dublicated argument: "s + *t);
        value = *(t + 1);
    } /*
#ifndef NDEBUG
    for (auto& [key, value] : args)
        std::cout << key << ':' << value << '\n';
#endif // NDEBUG
 */
    return { args["--file"], convert(args["--from"]), convert(args["--to"]) };
}


void skip_one_stick(std::istream& in) {
    char c = ' ';
    if (!(in >> c)) throw std::runtime_error("Cannot skip stick");
    if (c != '|') throw std::runtime_error("Invalid skip symbol");
}

void check_eof(std::istream& in) {
    char c = ' ';
    if (!(in >> c)) {
        if (!in.eof()) throw std::runtime_error("Bad EOF");
        return;
    }
    if (c != '|') throw std::runtime_error("Invalid end of row");
    in.unget();
}

//до сюда идет парсинг строк

void check_matrix(const std::vector<std::vector<weight_t>>& vec_of_vec) {
    for (const auto& vec : vec_of_vec) {
        if (vec.size() != vec_of_vec.begin()->size())
            throw std::runtime_error("Different size ");
    }
    if (vec_of_vec.size() != vec_of_vec.begin()->size())throw std::runtime_error("Not square");
}


matrix_t load_matrix(const char* filename) {
    std::ifstream file(filename);
    if (!file.is_open()) throw std::runtime_error("No such file");
    std::vector<std::vector<weight_t>>vec_of_vec;
    weight_t el = 0.0;
    while (!file.eof()) {
        std::vector<weight_t> vec;
        skip_one_stick(file);
        while (file >> el)
            vec.push_back(el);
        file.clear();
        skip_one_stick(file);
        check_eof(file);
        vec_of_vec.push_back(vec);


    }
    check_matrix(vec_of_vec);
    matrix_t matr(vec_of_vec.size(), vec_of_vec.begin()->size());
    size_t i = 0;
    for (const auto& vec : vec_of_vec)
        std::copy(vec.begin(), vec.end(), matr.begin() + (i++) * vec.size());
    return matr;
}



